GoldenRun = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceDB-2.0", "AceConsole-2.0", "AceHook-2.1", "AceDebug-2.0")
GoldenRun.revision = tonumber(("$Revision: 1$"):match("%d+"))

GoldenRun:RegisterDB("GoldenRunDB")

GoldenRun:RegisterDefaults('profile', {
	delay = 0.3,
    key = false,
	mouse = true,
	instance = {
		party = true,
		raid = true,
		pvp = true,
		arena = true,
		none = true,
	},
})

GoldenRun:RegisterChatCommand({ "/goldenrun", "/gr" }, {
	type = 'group',
	args = {
		delay = {
			type = 'range',
			name = "Delay",
			desc = "Doubleclick delay",
			get = function() return GoldenRun.db.profile.delay end,
			set = function(v) GoldenRun.db.profile.delay = v end,
			min = 0,
			max = 1,
			step = 0.05,
		},
		key = {
			type = 'toggle',
			name = "Key",
			desc = "Key autorun",
			get = function() return GoldenRun.db.profile.key end,
			set = function(v) GoldenRun.db.profile.key = v end,
			disabled = true,
		},
		mouse = {
			type = 'toggle',
			name = "Mouse",
			desc = "Mouse autorun",
			get = function() return GoldenRun.db.profile.mouse end,
			set = function(v) GoldenRun.db.profile.mouse = v end,
		},
		instance = {
			type = 'text',
			name = "Instance",
			desc = "Instance types to enable in",
			multiToggle = true,
			get = function(k) return GoldenRun.db.profile.instance[k] end,
			set = function(k,v) GoldenRun.db.profile.instance[k] = v end,
			validate = { ["party"] = "5 man", ["raid"] = "Raid", ["pvp"] = "Battleground", ["arena"] = "Arena" },
		},
	},
})

local ACTIONDOUBLEWAIT
function GoldenRun:OnInitialize()
	self.frame = CreateFrame("frame")
	ACTIONDOUBLEWAIT = self.db.profile.delay
end

function GoldenRun:OnEnable()
	--self:RegisterEvent("UPDATE_BINDINGS")
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
	self:HookScript(WorldFrame, "OnMouseDown")
	self:HookScript(WorldFrame, "OnMouseUp")
	--self:SecureHook("MoveForwardStart")
	--self:SecureHook("MoveForwardStop")
--	self:SetDebugging(true)
end

--[[
local keyBindings = {}
function GoldenRun:UPDATE_BINDINGS()
	keyBindings = { GetBindingKey("MOVEFORWARD") }
end
--]]

local instanceCheck
function GoldenRun:PLAYER_ENTERING_WORLD()
	instanceCheck = self.db.profile.instance[select('2',IsInInstance())] or false
end

local mouseOverrideOn, keyOverrideOn
function GoldenRun:PLAYER_REGEN_DISABLED()
	if mouseOverrideOn or keyOverrideOn then
		ClearOverrideBindings(self.frame)
		mouseOverrideOn = false
		keyOverrideOn = false
		self:Debug("Override OFF (combat)")
	end
end

-- Code for checking for double mouse clicks is from FishingAce, which is based on code from the Cosmos team
local lastMouseClickTime = nil
local function CheckForDoubleMouseClick()
	if lastMouseClickTime then
		local pressTime = GetTime()
		local doubleTime = pressTime - lastMouseClickTime
		lastMouseClickTime = pressTime
		if doubleTime < ACTIONDOUBLEWAIT then
			return true
		end
	end
	lastMouseClickTime = GetTime()
	return false
end

function GoldenRun:OnMouseDown(object, button)
	if button == "LeftButton" and self.db.profile.mouse and IsMouseButtonDown("RightButton") and not InCombatLockdown() and instanceCheck then
		if CheckForDoubleMouseClick() then
			SetOverrideBinding(self.frame, true, "BUTTON1", "TOGGLEAUTORUN")
			mouseOverrideOn = true
			self:Debug("Mouse Override ON")
		end
	end
	return self.hooks[object].OnMouseDown(object, button)
end

function GoldenRun:OnMouseUp(object, button)
	if self.db.profile.mouse and IsMouseButtonDown("RightButton") and not InCombatLockdown() and mouseOverrideOn then
		ClearOverrideBindings(self.frame)
		mouseOverrideOn = false
		self:Debug("Mouse Override OFF (%s Up)", button)
	end
	return self.hooks[object].OnMouseUp(object, button)
end

--[[
local lastKeyClickTime = nil
local function CheckForDoubleKeyClick()
	if lastKeyClickTime then
		local pressTime = GetTime()
		local doubleTime = pressTime - lastKeyClickTime
		lastKeyClickTime = pressTime
		if doubleTime < ACTIONDOUBLEWAIT then
			return true
		end
	end
	lastKeyClickTime = GetTime()
	return false
end

function GoldenRun:MoveForwardStart()
end

function GoldenRun:MoveForwardStop()
	if self.db.profile.key and not InCombatLockdown() and CheckForDoubleKeyClick() then
		for _,v in pairs(keyBindings) do
			SetOverrideBinding(self.frame, true, v, "TOGGLEAUTORUN")
		end
		keyOverrideOn = true
		self:Debug("Key Override ON")
	end
	--if not InCombatLockdown() and keyOverrideOn then
	--	ClearOverrideBindings(self.frame)
	--	keyOverrideOn = false
	--	self:Debug("Key Override OFF")
	--end
end
--]]
